c     ******************************************************************
c     * MCCCS - Towhee: A Monte Carlo molecular simulation program     *
c     * Copyright (C) 2005-2005 Marcus G. Martin                       *
c     *                                                                *
c     * This program is free software; you can redistribute it and/or  *
c     * modify it under the terms of the GNU General Public License    *
c     * as published by the Free Software Foundation; either version 2 *
c     * of the License, or (at your option) any later version.         *
c     *                                                                *
c     * This program is distributed in the hope that it will be useful,*
c     * but WITHOUT ANY WARRANTY; without even the implied warranty of *
c     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  *
c     * GNU General Public License for more details.                   *
c     *                                                                *
c     * You should have received a copy of the GNU General Public      *
c     * License along with this program; if not, write to the Free     *
c     * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,*
c     * MA  02111-1307, USA.                                           *
c     ******************************************************************
      program maftodensity
c     ******************************************************************
c     * this program converts the x,y, and z profiles from the         *
c     * probability density format generated by analyse_movie into     *
c     * real density units.                                            *
c     *                                                                *
c     * originally written 09-22-2005 by M.G. Martin                   *
c     * last modified 09-22-2005 by M.G. Martin                        *
c     ******************************************************************
      implicit none
      character*30 infile
      character*35 outfile
      integer iline,nline
      double precision boxlength,density,aaa,bbb

      write(6,*) 'Enter the filename to convert'
      read(5,*) infile
      open(20,file=infile,form='formatted')

c     --- open the output file
      outfile = 'den.'
      outfile(5:35) = infile(1:30)
      open(10,file=outfile,form='formatted')

      write(6,*) 'Enter the number of lines in the file'
      read(5,*) nline

      write(6,*) 'Enter the average box length in this direction'
      read(5,*) boxlength

      write(6,*) 'Enter the average number density in this box'
      read(5,*) density

      do iline = 1,nline
         read(20,*) aaa,bbb
         write(10,*) aaa*boxlength,bbb*density
      enddo

      close(10)
      close(20)
      end
